unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, TARadialSeries, TATools,
  TAIntervalSources, TAChartListbox, DateTimePicker, Forms, Controls, Graphics,
  Dialogs, Menus, ComCtrls, Grids, ExtCtrls, StdCtrls, EditBtn, MaskEdit, Spin,
  XMLPropStorage, typinfo, dateutils, LoadSaveConfig,
  measfile, chartprop, Types, Strutils, DefaultTranslator, Buttons;

type
  TIArray = array[1..defaultDeviceCount] of double;

  { TMainForm }

  TMainForm = class(TForm)
    ClearDisconnectionButton: TButton;
    CbStabilityType: TComboBox;
    DisconnectionStatusLabel: TLabel;
    DisconnectionStatusEdit: TEdit;
    Ir10Line: TLineSeries;
    Ir11Line: TLineSeries;
    Ir12Line: TLineSeries;
    Ir13Line: TLineSeries;
    Ir14Line: TLineSeries;
    Ir15Line: TLineSeries;
    Ir16Line: TLineSeries;
    Ir1Line: TLineSeries;
    Ir2Line: TLineSeries;
    Ir3Line: TLineSeries;
    Ir4Line: TLineSeries;
    Ir5Line: TLineSeries;
    Ir6Line: TLineSeries;
    Ir7Line: TLineSeries;
    Ir8Line: TLineSeries;
    Ir9Line: TLineSeries;
    IrCurrentChart: TChart;
    Label7: TLabel;
    AcquisitionRateDisplay: TLabel;
    OpenWaveMenuItem: TMenuItem;
    SaveWaveMenuItem: TMenuItem;
    N1: TMenuItem;
    TminValue: TLabel;
    TMaxLabel: TLabel;
    TMinLabel: TLabel;
    LoadFileProgressBar: TProgressBar;
    HelpMenuItem: TMenuItem;
    ManualMenuItem: TMenuItem;
    MenuItem6: TMenuItem;
    AboutMenuItem: TMenuItem;
    SumIdValuelb: TLabel;
    SumIdlb: TLabel;
    SumIrValuelb: TLabel;
    SumIrlb: TLabel;
    TmaxValue: TLabel;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    WaveformChartList: TChartListbox;
    ChartPopupMenu: TPopupMenu;
    ChartPropMenuItem: TMenuItem;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    I10Line: TLineSeries;
    I11Line: TLineSeries;
    I12Line: TLineSeries;
    I13Line: TLineSeries;
    I14Line: TLineSeries;
    I15Line: TLineSeries;
    I16Line: TLineSeries;
    I1Line: TLineSeries;
    I2Line: TLineSeries;
    I3Line: TLineSeries;
    I4Line: TLineSeries;
    I5Line: TLineSeries;
    I6Line: TLineSeries;
    I7Line: TLineSeries;
    I8Line: TLineSeries;
    I9Line: TLineSeries;
    CurrentValuesLb: TLabel;
    OverviewGrid: TStringGrid;
    tsOverview: TTabSheet;
    WaveformChart: TChart;
    LegendVisibleMenuItem: TMenuItem;
    MeasIntervalEdit: TMaskEdit;
    Memo1: TMemo;
    MenuItem3: TMenuItem;
    MenuItemDebugChannel: TMenuItem;
    T1Line: TLineSeries;
    T10Line: TLineSeries;
    T11Line: TLineSeries;
    T12Line: TLineSeries;
    T13Line: TLineSeries;
    T14Line: TLineSeries;
    T15Line: TLineSeries;
    T16Line: TLineSeries;
    T2Line: TLineSeries;
    T3Line: TLineSeries;
    T4Line: TLineSeries;
    T5Line: TLineSeries;
    T6Line: TLineSeries;
    T7Line: TLineSeries;
    T8Line: TLineSeries;
    T9Line: TLineSeries;
    Ib1Line: TLineSeries;
    Ib2Line: TLineSeries;
    Ib11Line: TLineSeries;
    Ib12Line: TLineSeries;
    Ib13Line: TLineSeries;
    Ib3Line: TLineSeries;
    Ib4Line: TLineSeries;
    Ib5Line: TLineSeries;
    Ib6Line: TLineSeries;
    Ib7Line: TLineSeries;
    Ib8Line: TLineSeries;
    Ib9Line: TLineSeries;
    Ib10Line: TLineSeries;
    Ib14Line: TLineSeries;
    Ib15Line: TLineSeries;
    Ib16Line: TLineSeries;
    NoteEdit: TEdit;
    Label6: TLabel;
    IrCurrentGrid: TStringGrid;
    IbCurrentChart: TChart;
    IbCurrentGrid: TStringGrid;
    EndDatePicker: TDateTimePicker;
    Label5: TLabel;
    OpenMeasFileDialog: TOpenDialog;
    Splitter5: TSplitter;
    StartDatePicker: TDateTimePicker;
    MenuItem4: TMenuItem;
    MenuDefaulDeviceAliases: TMenuItem;
    MenuItem5: TMenuItem;
    SaveMeasFileDialog: TSaveDialog;
    TabSheet1: TTabSheet;
    tsIrCurrent: TTabSheet;
    tsIbCurrent: TTabSheet;
    VoltageChart: TChart;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    UrLine: TLineSeries;
    UbLine: TLineSeries;
    VoltageGrid: TStringGrid;
    TemperatureGrid: TStringGrid;
    TemperatureChart: TChart;
    gbMeasurementSettings: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    MeasTimeEdit: TMaskEdit;
    MenuImageList: TImageList;
    MainMenu: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItemTest: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItemCalibration: TMenuItem;
    MenuItemChannels: TMenuItem;
    MenuItemStopTest: TMenuItem;
    MenuItemRunTest: TMenuItem;
    MenuItemNewTest: TMenuItem;
    MenuItemQuit: TMenuItem;
    MenuItemSaveAs: TMenuItem;
    MenuItemOpen: TMenuItem;
    MenuFile: TMenuItem;
    OpenBtn: TToolButton;
    pcCharts: TPageControl;
    SaveAsBtn: TToolButton;
    StatusBar: TStatusBar;
    DeviceGrid: TStringGrid;
    tsVoltage: TTabSheet;
    tsTemperature: TTabSheet;
    ToolBarMenuFile: TToolBar;
    ToolButton1: TToolButton;
    NewBtn: TToolButton;
    RunBtn: TToolButton;
    StopBtn: TToolButton;
    ULine: TLineSeries;
    XMLPropStorage: TXMLPropStorage;
    procedure CbStabilityTypeChange(Sender: TObject);
    procedure ChartPopupMenuPopup(Sender: TObject);
    procedure ChartPropMenuItemClick(Sender: TObject);
    procedure ChartToolsetDataPointHintTool1Hint(ATool: TDataPointHintTool;
      const APoint: TPoint; var AHint: String);
    procedure ChartToolsetDataPointHintTool1HintPosition(
      ATool: TDataPointHintTool; var APoint: TPoint);
    procedure DeviceDisconnectionPLCTagUpdate(Sender: TObject);
    procedure DeviceGridCheckboxToggled(sender: TObject; aCol, aRow: Integer;
      aState: TCheckboxState);
    procedure DeviceGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure IbCurrentGridDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure IrCurrentGridDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure LegendVisibleMenuItemClick(Sender: TObject);
    procedure MeasIntervalEditEditingDone(Sender: TObject);
    procedure MeasTimeEditEditingDone(Sender: TObject);
    procedure MenuDefaulDeviceAliasesClick(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItemCalibrationClick(Sender: TObject);
    //init values in Devicegrid
    procedure InitDeviceTable;
    //init values in MeasurementGroupBox
    procedure InitTestSettigns;
    //
    procedure InitCharts;
    //set cols, rows and titles of current,temperatureresult tables
    procedure BuildTable(_AStringGrid:TStringGrid; ARowCount,AColCount:integer;AColTitlePrefix:string);
     //set cols, rows and titles of voltage result tables
    procedure BuildVoltageTable(_AStringGrid:TStringGrid; ARowCount,AColCount:integer);
    procedure BuildOverviewTable(_AStringGrid:TStringGrid; ARowCount,AColCount:integer; AColTitlePrefix:string);
    procedure MenuItemDebugChannelClick(Sender: TObject);
    procedure OverviewGridDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure OverviewGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);
    procedure SaveAsBtnClick(Sender: TObject);
    procedure SaveWaveMenuItemClick(Sender: TObject);

    //set properties to save
    procedure SetMainFormPropToSave;
    procedure NewBtnClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure RunBtnClick(Sender: TObject);
    procedure StatusBarDrawPanel(AStatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure StopBtnClick(Sender: TObject);
    procedure TemperatureGridDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure ToolButton2Click(Sender: TObject);
    procedure VoltageGridDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure ClearDisconnectionButtonClick(Sender: TObject);

  private

    ReadMeasFileThread: TReadMeasFileThread;
    { private declarations }
  public
    { public declarations }
  end;

resourcestring

  IrStr = 'Ir, [mA]';
  IdStr = 'Id, [mA]';
  IrMaxStr = 'Ir max, [mA]';
  IdMaxStr = 'Id max, [mA]';
  CurrentLimitStr ='Current limit, [mA]';
  UStr = 'U, [V]';
  UrStr = 'Ur, [V]';
  UdStr = 'Ud, [V]';
  DateStr = 'Date';
  TimeStr = 'Time';
  TemperatureStr = 'T, [°C]';
  DCStabilityStr = 'DC';
  HalfSinStabilityStr = 'Half sine';
  FullSinStabilityStr = 'Full sine';
  CaptionNoteInputBoxStr = 'Note';
  PromptNoteInputBoxStr = 'Please enter a note here';
  DefaultNoteInputBoxStr = 'Stability test';
  SampleNumberStr = 'Sample number';
  IUstr = 'I, [mA] / U[kV]';
  TestRunningStr = 'TEST IS RUNNING...';
  TestStoppedStr = 'TEST STOPPED';
  TestWithLogging = 'WITH LOGGING';
  TestWithoutLogging = 'WITHOUT LOGGING';
  SumIrStr = 'Sum Ir, [mA]';
  SumIdStr = 'Sum Id, [mA]';

  WantCloseProgramStr = 'Do you really want to close test program?';
  DeviceAliasStr = 'Device alias';


var
  MainForm: TMainForm;

  MeasFileName: string = '';
  //Limit proudu pro odepnuti soucastky
  CurrentLimits: TIArray = (50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50);
  //test
  AIrArr: TIArray = (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16);
  AIbArr: TIArray = (17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32);
  ATArr: TIArray =  (33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48);
  AUr: double = 1005;
  Aub: double = 2005;


implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.DeviceGridCheckboxToggled(sender: TObject; aCol,
  aRow: Integer; aState: TCheckboxState);
begin
   if ACol = 2 then begin
     IrCurrentGrid.Columns.Items[ARow+1].Visible := boolean(Ord(aState));
     IbCurrentGrid.Columns.Items[ARow+1].Visible := boolean(Ord(aState));
     TemperatureGrid.Columns.Items[ARow+1].Visible := boolean(Ord(aState));

     IrCurrentChart.Series.Items[ARow-1].Active := boolean(Ord(aState));
     IbCurrentChart.Series.Items[ARow-1].Active := boolean(Ord(aState));
     TemperatureChart.Series.Items[ARow-1].Active := boolean(Ord(aState));

     OverviewGrid.Columns.Items[ARow-1].Visible := boolean(Ord(aState));
     WaveformChartList.Checked[ARow-1] := boolean(Ord(aState));
     DeviceCheckedList[ARow-1] := boolean(Ord(aState));
  end;
end;

procedure TMainForm.CbStabilityTypeChange(Sender: TObject);
begin
 CbStabilityType.Width := CbStabilityType.Canvas.GetTextWidth(CbStabilityType.Text) + 8;
end;

procedure TMainForm.ChartPopupMenuPopup(Sender: TObject);
begin
  if MainForm.ActiveControl is TChart then
    LegendVisibleMenuItem.Checked:= (MainForm.ActiveControl as TChart).Legend.Visible;
end;


procedure TMainForm.ChartPropMenuItemClick(Sender: TObject);
begin
  try
    ChartPropForm := TChartPropForm.Create(Nil);
    with ChartPropForm do begin
      Caption :=  Caption + ' ' +MainForm.pcCharts.ActivePage.Caption;
      if MainForm.ActiveControl is TChart
        then ChartPropForm._TChart :=  MainForm.ActiveControl as TChart;
    end;
    ChartPropForm.ShowModal;
  finally
    FreeAndNil(ChartPropForm);
  end;
end;

procedure TMainForm.ChartToolsetDataPointHintTool1Hint(
  ATool: TDataPointHintTool; const APoint: TPoint; var AHint: String);
begin
  AHint :=  TLineSeries(ATool.Series).Title + sLineBreak
    + DateStr + ': '+ DateTimeToStr(ATool.NearestGraphPoint.X) + sLineBreak
    + format(Copy2Symb(ATool.Chart.AxisList.Axes[0].Title.Caption,',') + ' = %-8.1f',[ATool.NearestGraphPoint.Y]);
end;

procedure TMainForm.ChartToolsetDataPointHintTool1HintPosition(
  ATool: TDataPointHintTool; var APoint: TPoint);
begin
  APoint.x := APoint.x + 20;
end;

procedure TMainForm.DeviceDisconnectionPLCTagUpdate(Sender: TObject);
begin
  //DisconnectionStatusEdit.Text := IntToBin(Round(DeviceDisconnectionPLCTag.Value),16);
end;

procedure TMainForm.DeviceGridSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: string);
begin
  if ACol = 1 then begin
     IrCurrentGrid.Columns.Items[ARow+1].Title.Caption := IrStr + sLineBreak + Value;
     TemperatureGrid.Columns.Items[ARow+1].Title.Caption := TemperatureStr + sLineBreak + Value;
     if IrCurrentGrid.Canvas.GetTextWidth(Value) >  IrCurrentGrid.Canvas.GetTextWidth(IrStr)
       then IrCurrentGrid.Columns.Items[ARow+1].Width := IrCurrentGrid.Canvas.GetTextWidth(Value) + 12
       else IrCurrentGrid.Columns.Items[ARow+1].Width := IrCurrentGrid.Canvas.GetTextWidth(IrStr) + 12;

     IbCurrentGrid.Columns.Items[ARow+1].Title.Caption := IdStr + sLineBreak + Value;
     TemperatureGrid.Columns.Items[ARow+1].Title.Caption := TemperatureStr + sLineBreak + Value;
     if IbCurrentGrid.Canvas.GetTextWidth(Value) >  IbCurrentGrid.Canvas.GetTextWidth(IdStr)
       then IbCurrentGrid.Columns.Items[ARow+1].Width := IbCurrentGrid.Canvas.GetTextWidth(Value) + 12
       else IbCurrentGrid.Columns.Items[ARow+1].Width := IbCurrentGrid.Canvas.GetTextWidth(IdStr) + 12;

     if TemperatureGrid.Canvas.GetTextWidth(Value) >  TemperatureGrid.Canvas.GetTextWidth(IrStr)
       then TemperatureGrid.Columns.Items[ARow+1].Width := TemperatureGrid.Canvas.GetTextWidth(Value) + 12
       else TemperatureGrid.Columns.Items[ARow+1].Width := TemperatureGrid.Canvas.GetTextWidth(TemperatureStr) + 12;

     TLineSeries(IrCurrentChart.Series.Items[ARow-1]).Title :=    Value;
     TLineSeries(IbCurrentChart.Series.Items[ARow-1]).Title :=    Value;
     TLineSeries(TemperatureChart.Series.Items[ARow-1]).Title :=  Value;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SetMainFormPropToSave;
  LoadDAQCardIni;
  LoadCalibrationIni;
  InitDeviceTable;
  InitTestSettigns;
  InitCharts;
  BuildTable(IrCurrentGrid,1,DeviceCount,IrStr);
  BuildTable(IbCurrentGrid,1,DeviceCount,IdStr);
  BuildTable(TemperatureGrid,1,DeviceCount,TemperatureStr);
  BuildVoltageTable(VoltageGrid,1,4);
  BuildOverviewTable(OverviewGrid,9,DeviceCount,'');
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Splitter2.Top := 3*tsIrCurrent.Height div 4;
  Splitter3.Top := 3*tsIbCurrent.Height div 4;
  Splitter4.Top := 3*tsTemperature.Height div 4;
  Splitter5.Top := 3*tsVoltage.Height div 4;
end;

procedure TMainForm.IbCurrentGridDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  Grid: TStringGrid;
begin
  Grid := Sender as TStringGrid;
  if (Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16) > Grid.ColWidths[aCol]
      then Grid.ColWidths[aCol] := Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16;
  //if Grid.RowCount > 11 then Grid.TopRow := Grid.RowCount - 10;
end;

procedure TMainForm.IrCurrentGridDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  Grid: TStringGrid;
begin
  Grid := Sender as TStringGrid;
  if (Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16) > Grid.ColWidths[aCol]
      then Grid.ColWidths[aCol] := Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16;
  //if Grid.RowCount > 11 then Grid.TopRow := Grid.RowCount - 10;
end;

procedure TMainForm.LegendVisibleMenuItemClick(Sender: TObject);
begin
  if MainForm.ActiveControl is TChart then begin
     LegendVisibleMenuItem.Checked := NOT(LegendVisibleMenuItem.Checked);
     (MainForm.ActiveControl as TChart).Legend.Visible := LegendVisibleMenuItem.Checked;
  end;
end;

procedure TMainForm.MeasIntervalEditEditingDone(Sender: TObject);
var
  i: integer;
  nn, ss: byte; //minutes, seconds
  s: string;
begin
  for i:= 1 to Length(MeasIntervalEdit.Text) do
    if MeasIntervalEdit.Text[i] = ' ' then s := s +'0'
      else s := s + MeasIntervalEdit.Text[i];
  MeasIntervalEdit.Text := s;
  nn := StrToInt(Trim(Copy(MeasIntervalEdit.Text,1,2)));
  ss := StrToInt(Trim(Copy(MeasIntervalEdit.Text,4,2)));
  if ss >= 60 then begin
    nn := nn + (ss div 60);
    ss := ss - 60;
    MeasIntervalEdit.Text := format('%0:2.2d',[nn])+':'+format('%0:2.2d',[ss]);
  end;
end;

procedure TMainForm.MeasTimeEditEditingDone(Sender: TObject);
var
  i:integer;
  hhhh:word; //hours
  nn:byte; //minutes
  s:string;
begin
  for i:= 1 to Length(MeasTimeEdit.Text) do
   if MeasTimeEdit.Text[i] = ' ' then s:= s + '0'
      else  s := s + MeasTimeEdit.Text[i];
  MeasTimeEdit.Text := s;
  hhhh := StrToInt(Trim(Copy(MeasTimeEdit.Text,1,4)));
  nn := StrToInt(Trim(Copy(MeasTimeEdit.Text,6,2)));
  if nn >= 60 then begin
    hhhh := hhhh + (nn div 60);
    nn := nn - 60;
    MeasTimeEdit.Text := format('%0:4.4d',[hhhh])+':'+format('%0:2.2d',[nn]);
  end;
  EndDatePicker.DateTime := IncHour(StartDatePicker.DateTime,hhhh);
  EndDatePicker.DateTime := IncMinute(EndDatePicker.DateTime,nn);
end;

procedure TMainForm.MenuDefaulDeviceAliasesClick(Sender: TObject);
begin
  //DeviceAliasesForm := TDeviceAliasesForm.Create(Nil);
  //try
  //  DeviceAliasesForm.ShowModal;
  //finally
  //  DeviceAliasesForm.Free;
  //end;
end;

procedure TMainForm.MenuItem5Click(Sender: TObject);
begin
  //DAQCardForm := TDAQCardForm.Create(Nil);
  //try
  //  DAQCardForm.ShowModal;
  //finally
  //  DAQCardForm.Free;
  //end;
end;

procedure TMainForm.MenuItemCalibrationClick(Sender: TObject);
begin
  //CalibrationForm := TCalibrationForm.Create(Nil);
  //try
  //  CalibrationForm.ShowModal;
  //finally
  //  CalibrationForm.Free;
  //end;
end;

procedure TMainForm.InitDeviceTable;
var
  i:integer;
begin
  LoadDefaultDeviceAliasesToGridCol(DeviceGrid.Cols[1]);

  DeviceGrid.Columns.Items[0].Title.Caption := DeviceAliasStr;

  for i:= 1 to DeviceGrid.RowCount-1 do DeviceGrid.Cells[2,i] := '1';
  DeviceGrid.ColWidths[0] := DeviceGrid.Canvas.GetTextWidth('11') + 8;
  DeviceGrid.ColWidths[2] := (DeviceGrid.Width - DeviceGrid.ColWidths[0]) div 2;
  DeviceGrid.ColWidths[1] := (DeviceGrid.Width - DeviceGrid.ColWidths[0]) div 2;
end;

procedure TMainForm.InitTestSettigns;
begin
  //load values to cbStabilityType
  CbStabilityType.Width := CbStabilityType.Canvas.GetTextWidth(DCStabilityStr) + 8;
  cbStabilityType.Items.Add(DCStabilityStr);
  cbStabilityType.Items.Add(HalfSinStabilityStr);
  cbStabilityType.Items.Add(FullSinStabilityStr);
  cbStabilityType.ItemIndex := 0;

  MeasTimeEdit.Text := '0001:00';
  MeasIntervalEdit.Text := '10:00';
  StartDatePicker.DateTime := Now;
  EndDatePicker.DateTime := IncHour(Now,StrToInt(Copy(MeasTimeEdit.Text,1,4)));
  EndDatePicker.DateTime := IncMinute(EndDatePicker.DateTime,StrToInt(Copy(MeasTimeEdit.Text,6,2)));
end;

procedure TMainForm.InitCharts;
var
  i:integer;
  Colors: array [0..15] of TColor = (
    $00000099,
    $00009999,
    $00009900,
    $00999900,
    $00990000,
    $00990099,
    $000000FF,
    $0000FFFF,
    $0000FF00,
    $00FFFF00,
    $00FF00FF,
    $00FFCC00,
    $00CC6600,
    $009999CC,
    $003399FF,
    $006666CC
   );
begin
  IrCurrentChart.AxisList.Axes[0].Title.Caption := IrStr;
  IrCurrentChart.AxisList.Axes[1].Title.Caption := DateStr;
  for i:= 1 to DeviceGrid.RowCount-1 do
    if IrCurrentChart.Series.Count >= i then begin
      TLineSeries(IrCurrentChart.Series.Items[i-1]).Title := DeviceGrid.Cells[1,i];
      TLineSeries(IrCurrentChart.Series.Items[i-1]).LinePen.Color := Colors [i-1];
      TLineSeries(IrCurrentChart.Series.Items[i-1]).LinePen.Width := 2;
    end;



  IbCurrentChart.AxisList.Axes[0].Title.Caption := IdStr;
  IbCurrentChart.AxisList.Axes[1].Title.Caption := DateStr;
  for i:= 1 to DeviceGrid.RowCount-1 do
   if IbCurrentChart.Series.Count >= i then begin
     TLineSeries(IbCurrentChart.Series.Items[i-1]).Title := DeviceGrid.Cells[1,i];
     TLineSeries(IbCurrentChart.Series.Items[i-1]).LinePen.Color := Colors [i-1];
     TLineSeries(IbCurrentChart.Series.Items[i-1]).LinePen.Width := 2;
   end;

  TemperatureChart.AxisList.Axes[0].Title.Caption := TemperatureStr;
  TemperatureChart.AxisList.Axes[1].Title.Caption := DateStr;
  for i:= 1 to DeviceGrid.RowCount-1 do
    if TemperatureChart.Series.Count >= i then begin
      TLineSeries(TemperatureChart.Series.Items[i-1]).Title := DeviceGrid.Cells[1,i];
      TLineSeries(TemperatureChart.Series.Items[i-1]).LinePen.Color := Colors [i-1];
      TLineSeries(TemperatureChart.Series.Items[i-1]).LinePen.Width := 2;
    end;

  VoltageChart.AxisList.Axes[0].Title.Caption := UStr;
  VoltageChart.AxisList.Axes[1].Title.Caption := DateStr;
  if VoltageChart.Series.Count > 0 then TLineSeries(VoltageChart.Series.Items[0]).Title := UrStr;
  if VoltageChart.Series.Count > 1 then TLineSeries(VoltageChart.Series.Items[1]).Title := UdStr;

  //Waveform chart
  for i:= 1 to 16 do  begin
    TLineSeries(WaveformChart.Series.Items[i-1]).Title := 'I' + IntToStr(i);
    TLineSeries(WaveformChart.Series.Items[i-1]).LinePen.Color := Colors [i-1];
    TLineSeries(WaveformChart.Series.Items[i-1]).LinePen.Width := 2;
  end;
  TLineSeries(WaveformChart.Series.Items[16]).Title := 'U';

  WaveformChart.AxisList.Axes[1].Title.Visible := True;
  WaveformChart.AxisList.Axes[1].Title.Caption := TimeStr +',[ms]';
  WaveformChart.AxisList.Axes[0].Title.Visible := True;
  WaveformChart.AxisList.Axes[0].Title.Caption := IUstr;
end;

procedure TMainForm.BuildTable(_AStringGrid:TStringGrid; ARowCount,AColCount:integer;AColTitlePrefix:string);
var
  i:integer;
begin
  //set row count to 2
  _AStringGrid.RowCount := ARowCount;
  //set height of first row to 2 lines
  _AStringGrid.RowHeights[0] := 2 * _AStringGrid.Canvas.GetTextHeight('D') + 12;
  //add collums with title to Current and Temperature tables
  for i:=0 to AColCount-1+2 do begin
       if _AStringGrid.Columns.Count <  AColCount+2 then _AStringGrid.Columns.Add;
       _AStringGrid.Columns.Items[i].Alignment := taRightJustify;
       _AStringGrid.Columns.Items[i].Title.Alignment := taCenter;
       _AStringGrid.Columns.Items[i].Title.MultiLine := True;
       case i of
         0 :  begin
                _AStringGrid.Columns.Items[i].Title.Caption := DateStr;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth(FormatSettings.LongDateFormat) + 18;
         end;
         1 :  begin
                _AStringGrid.Columns.Items[i].Title.Caption := TimeStr;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth(FormatSettings.LongTimeFormat) + 18;
         end
         else begin
                _AStringGrid.Columns.Items[i].Title.Caption := AColTitlePrefix + sLineBreak + DeviceGrid.Cells[1,i+1-2] ;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth(DeviceGrid.Cells[1,i+1-2]) + 18;
         end;
       end;
  end;
end;


procedure TMainForm.BuildOverviewTable(_AStringGrid: TStringGrid; ARowCount,
  AColCount: integer; AColTitlePrefix: string);
var
  i:integer;
begin
  _AStringGrid.RowCount := ARowCount;
  //add collums with title to Current and Temperature tables
  for i:= 0 to AColCount-1  do begin
    _AStringGrid.Columns.Add;
    _AStringGrid.Columns.Items[i].Alignment := taRightJustify;
    _AStringGrid.Columns.Items[i].Title.Alignment := taCenter;
    _AStringGrid.Columns.Items[i].Title.Caption := AColTitlePrefix + sLineBreak + DeviceGrid.Cells[1,i+1] ;
    _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth(DeviceGrid.Cells[1,i+1]) + 18;
 end;

 _AStringGrid.Height := 6;
 for i:= 0 to _AStringGrid.RowCount - 1 do
   _AStringGrid.Height := _AStringGrid.Height + _AStringGrid.RowHeights[i];

  _AStringGrid.Cells[0,1] := IrStr;
  _AStringGrid.Cells[0,2] := IdStr;
  _AStringGrid.Cells[0,3] := TemperatureStr;
  _AStringGrid.Cells[0,4] := UrStr;
  _AStringGrid.Cells[0,5] := UdStr;
  _AStringGrid.Cells[0,6] := IrMaxStr;
  _AStringGrid.Cells[0,7] := IdMaxStr;
  _AStringGrid.Cells[0,8] := CurrentLimitStr;
  for i:= 0 to _AStringGrid.Columns.Count - 1 do
    _AStringGrid.Cells[i+1,8] := FloatToStrF(CurrentLimits[i+1],ffFixed,5,0);
end;


procedure TMainForm.BuildVoltageTable(_AStringGrid: TStringGrid; ARowCount,
  AColCount: integer);
var
  i:integer;
begin
  //set row count to 2
  _AStringGrid.RowCount := ARowCount;
  //set height of first row to 2 lines
  _AStringGrid.RowHeights[0] := 2 * _AStringGrid.Canvas.GetTextHeight('D') + 12;
   for i:=0 to AColCount-1 do begin
       _AStringGrid.Columns.Add;
       _AStringGrid.Columns.Items[i].Alignment := taRightJustify;
       _AStringGrid.Columns.Items[i].Title.Alignment := taCenter;
       _AStringGrid.Columns.Items[i].Title.MultiLine := True;
       case i of
         0 :  begin
                _AStringGrid.Columns.Items[i].Title.Caption := DateStr;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth(FormatSettings.LongDateFormat) + 18;
         end;
         1 :  begin
                _AStringGrid.Columns.Items[i].Title.Caption := TimeStr;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth(FormatSettings.LongTimeFormat) + 18;
         end;

         2 :  begin
                _AStringGrid.Columns.Items[i].Title.Caption := UrStr;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth('UrStr') + 18;
         end;
         3 :  begin
                _AStringGrid.Columns.Items[i].Title.Caption := UdStr;
                _AStringGrid.Columns.Items[i].Width := _AStringGrid.Canvas.GetTextWidth('UbStr') + 18;
         end;
       end;
   end;
end;

procedure TMainForm.MenuItemDebugChannelClick(Sender: TObject);
begin
  //try
  //  DebugChannelForm := TDebugChannelForm.Create(Nil);
  //  DebugChannelForm._DAQReadAnalog64 := DAQReadAnalog64;
  //  DebugChannelForm.ShowModal;
  //finally
  //  DebugChannelForm.Free;
  //end;
end;

procedure TMainForm.OverviewGridDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  Grid: TStringGrid;
begin
  Grid := Sender as TStringGrid;
  if (Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16) > Grid.ColWidths[aCol]
      then Grid.ColWidths[aCol] := Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16;

end;

procedure TMainForm.OverviewGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: string);
var
  FloatValue: double;
begin
  if (ARow = 8) and (ACol > 0) then
    if TryStrToFloat(Value,FloatValue) then CurrentLimits[ACol] := FloatValue
    else begin
      TStringGrid(Sender).Cells[ACol, ARow] := '0';
      CurrentLimits[ACol] := 0;
    end;
end;


procedure TMainForm.SaveAsBtnClick(Sender: TObject);
begin
  if SaveMeasFileDialog.Execute then begin
    CreateMeasFileHeader(SaveMeasFileDialog.FileName,StartDatePicker.DateTime,
         EndDatePicker.DateTime, NoteEdit.Text,CbStabilityType.Text);
    CreateMeasFileTableTitles(SaveMeasFileDialog.FileName, DeviceGrid.Cols[1]);
    WriteDataToMeasFileFromGrids(SaveMeasFileDialog.FileName, IrCurrentGrid, IbCurrentGrid, TemperatureGrid, VoltageGrid);
  end;
end;

procedure TMainForm.SaveWaveMenuItemClick(Sender: TObject);
begin
  if SaveMeasFileDialog.Execute then SaveWaveforms(WaveformChart, SaveMeasFileDialog.FileName);
end;

procedure TMainForm.SetMainFormPropToSave;
var
  i:integer;
begin

  XMLPropStorage.FileName := GetAppConfigDir(False) + 'mainform.xml';
  MainForm.SessionProperties := 'IrCurrentChart.Legend;' + 'IrCurrentChart.AxisList;' +
    'IbCurrentChart.Legend;' + 'IbCurrentChart.AxisList;' +
    'TemperatureChart.Legend;' + 'TemperatureChart.AxisList;' +
    'VoltageChart.Legend;' + 'VoltageChart.AxisList;';

  for i:= 0 to MainForm.IrCurrentChart.Series.Count-1 do begin
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IrCurrentChart.Series.Items[i].Name + '.LinePen;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IrCurrentChart.Series.Items[i].Name + '.Pointer;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IrCurrentChart.Series.Items[i].Name +'.ShowLines;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IrCurrentChart.Series.Items[i].Name +'.ShowPoints;'
  end;

  for i:= 0 to MainForm.IbCurrentChart.Series.Count-1 do begin
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IbCurrentChart.Series.Items[i].Name + '.LinePen;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IbCurrentChart.Series.Items[i].Name + '.Pointer;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IbCurrentChart.Series.Items[i].Name +'.ShowLines;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.IbCurrentChart.Series.Items[i].Name +'.ShowPoints;'
  end;

  for i:= 0 to MainForm.TemperatureChart.Series.Count-1 do begin
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.TemperatureChart.Series.Items[i].Name + '.LinePen;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.TemperatureChart.Series.Items[i].Name + '.Pointer;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.TemperatureChart.Series.Items[i].Name +'.ShowLines;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.TemperatureChart.Series.Items[i].Name +'.ShowPoints;'
  end;

  for i:= 0 to MainForm.VoltageChart.Series.Count-1 do begin
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.VoltageChart.Series.Items[i].Name + '.LinePen;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.VoltageChart.Series.Items[i].Name + '.Pointer;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.VoltageChart.Series.Items[i].Name +'.ShowLines;';
    MainForm.SessionProperties := MainForm.SessionProperties +
       MainForm.VoltageChart.Series.Items[i].Name +'.ShowPoints;'
  end;
end;

procedure TMainForm.NewBtnClick(Sender: TObject);
var
  i: integer;
begin
  if SaveMeasFileDialog.Execute then begin
    CreateMeasFileHeader(SaveMeasFileDialog.FileName,StartDatePicker.DateTime,
         EndDatePicker.DateTime, NoteEdit.Text,CbStabilityType.Text);
    CreateMeasFileTableTitles(SaveMeasFileDialog.FileName, DeviceGrid.Cols[1]);
    MeasFileName := SaveMeasFileDialog.FileName;
    MainForm.Caption := 'Test '+ MeasFileName;
    //clear charts and tables
    for i:=0 to IrCurrentChart.SeriesCount - 1 do TLineSeries(IrCurrentChart.Series.Items[i]).Clear;
    for i:=0 to IbCurrentChart.SeriesCount - 1 do TLineSeries(IbCurrentChart.Series.Items[i]).Clear;
    for i:=0 to TemperatureChart.SeriesCount - 1 do TLineSeries(TemperatureChart.Series.Items[i]).Clear;
    for i:=0 to VoltageChart.SeriesCount - 1 do TLineSeries(VoltageChart.Series.Items[i]).Clear;
    IrCurrentGrid.RowCount := 1;
    IbCurrentGrid.RowCount := 1;
    TemperatureGrid.RowCount := 1;
    VoltageGrid.RowCount := 1;
    RunBtnClick(Self);
  end;
end;

procedure TMainForm.OpenBtnClick(Sender: TObject);
var
  ANote: string;
  AStabilityType: string;
  AStartDate, AEndDate: TDateTime;
begin
  if OpenMeasFileDialog.Execute then begin
    ReadMeasFileHeader(OpenMeasFileDialog.FileName, AStartDate, AEndDate,ANote,AStabilityType);
    StartDatePicker.DateTime := AStartDate;
    EndDatePicker.DateTime := AEndDate;
    NoteEdit.Text := ANote;
    cbStabilityType.Text := AStabilityType;
    //titles
    ReadMeasFileTableTitles(OpenMeasFileDialog.FileName, DeviceGrid.Cols[1]);
    ReadMeasFileTableTitlesToCharts(OpenMeasFileDialog.FileName,IrCurrentChart,IbCurrentChart,TemperatureChart);
    BuildTable(IrCurrentGrid,1,DeviceCount,IrStr);
    BuildTable(IbCurrentGrid,1,DeviceCount,IdStr);
    BuildTable(TemperatureGrid,1,DeviceCount,TemperatureStr);
    //ReadDataFromMeasFileToGrids(OpenMeasFileDialog.FileName, IrCurrentGrid,
    //  IbCurrentGrid, TemperatureGrid, VoltageGrid, IrCurrentChart, IbCurrentChart, TemperatureChart, VoltageChart);

    ReadMeasFileThread := TReadMeasFileThread.Create(True);
    ReadMeasFileThread.FileName := OpenMeasFileDialog.FileName;
    ReadMeasFileThread.FileBufferSize := 1000;
    ReadMeasFileThread.IrGrid := IrCurrentGrid;
    ReadMeasFileThread.IbGrid := IbCurrentGrid;
    ReadMeasFileThread.TemperatureGrid := TemperatureGrid;
    ReadMeasFileThread.VoltageGrid := VoltageGrid;
    ReadMeasFileThread.IrChart := IrCurrentChart;
    ReadMeasFileThread.IbChart := IbCurrentChart;
    ReadMeasFileThread.TemperatureChart := TemperatureChart;
    ReadMeasFileThread.VoltageChart := VoltageChart;
    ReadMeasFileThread.ProgressBar := LoadFileProgressBar;
    ReadMeasFileThread.StatusPanel := StatusBar.Panels.Items[1];
    ReadMeasFileThread.Memo := Memo1;

    ReadMeasFileThread.Start;

    MeasFileName := OpenMeasFileDialog.FileName;
    MainForm.Caption := 'Test '+ MeasFileName;

  end;
end;

procedure TMainForm.RunBtnClick(Sender: TObject);
begin
  StartDatePicker.DateTime := Now;
  MeasTimeEditEditingDone(Self);

  StopBtn.Enabled := True;
  RunBtn.Enabled := False;



end;

procedure TMainForm.StatusBarDrawPanel(AStatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  Panel.Width := AStatusBar.Canvas.GetTextWidth(Panel.Text) + 8;
end;

procedure TMainForm.StopBtnClick(Sender: TObject);
begin

  StopBtn.Enabled := False;
  RunBtn.Enabled := True;
  StatusBar.SimpleText := TestStoppedStr;
end;


procedure TMainForm.TemperatureGridDrawCell(Sender: TObject; aCol,
  aRow: Integer; aRect: TRect; aState: TGridDrawState);
var
  Grid: TStringGrid;
begin
  Grid := Sender as TStringGrid;
  if (Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16) > Grid.ColWidths[aCol]
      then Grid.ColWidths[aCol] := Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16;
  //if Grid.RowCount > 11 then Grid.TopRow := Grid.RowCount - 10;
end;

procedure TMainForm.ToolButton2Click(Sender: TObject);
begin
   try
    ChartPropForm := TChartPropForm.Create(Nil);
    with ChartPropForm do begin
      Caption :=  Caption + ' ' +MainForm.pcCharts.ActivePage.Caption;
      if MainForm.ActiveControl is TChart
        then ChartPropForm._TChart :=  MainForm.ActiveControl as TChart;
    end;
    ChartPropForm.ShowModal;
  finally
    FreeAndNil(ChartPropForm);
  end;
end;

procedure TMainForm.VoltageGridDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  Grid: TStringGrid;
begin
  Grid := Sender as TStringGrid;
  if (Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16) > Grid.ColWidths[aCol]
      then Grid.ColWidths[aCol] := Grid.Canvas.GetTextWidth(Grid.Cells[aCol,aRow]) + 16;
  //if Grid.RowCount > 11 then Grid.TopRow := Grid.RowCount - 10;
end;

procedure TMainForm.ClearDisconnectionButtonClick(Sender: TObject);
begin
  //DeviceDisconnectionPLCTag.Write(0);
end;


initialization

  FormatSettings.LongDateFormat := 'DD.MM.YYYY';
  FormatSettings.LongTimeFormat := 'hh:nn:ss';

end.

